<script setup lang="ts" emits="closeDialog">
import { ref, defineEmits } from 'vue'
import promotionToEdit from '@/views/PromotionView.vue'
import http from '@/services/http'

const emits = defineEmits(['closeDialog', 'promotionCreated'])

const promotion = ref({
  name: '',
  condition: '',
  discount: 0,
  discountType: '', // เพิ่ม property สำหรับเก็บประเภทของส่วนลด
  start: '',
  end: '',
  status: false
})

const discountTypes = ['Cash', 'Percentage', 'Point'] // ประเภทของส่วนลด

const addPromotion = async () => {
  if (
    promotion.value.name.trim() !== '' &&
    promotion.value.condition.trim() !== '' &&
    promotion.value.discount > 0 &&
    promotion.value.discountType.trim() !== '' &&
    promotion.value.start.trim() !== '' &&
    promotion.value.end.trim() !== '' &&
    new Date(promotion.value.start) < new Date(promotion.value.end)
  ) {
    const newPromotion = {
      name: promotion.value.name.trim(),
      condition: promotion.value.condition.trim(),
      discount: promotion.value.discount,
      discountType: promotion.value.discountType, // ส่วนลดเป็นอะไร
      start: promotion.value.start.trim(),
      end: promotion.value.end.trim(),
      status: promotion.value.status
    }

    try {
      // ส่งคำขอสร้างโปรโมชั่นไปยังเซิร์ฟเวอร์
      const response = await http.post('/promotions', newPromotion)
      if (response.status === 201) {
        console.log('New promotion created successfully:', response.data)
        handleCloseDialog()
        emits('promotionCreated', response.data) // ส่งข้อมูล
      }
    } catch (error) {
      console.error('Error creating new promotion:', error)
    }
  } else {
    console.log('AddFail')
  }
}

const handleCloseDialog = () => {
  emits('closeDialog', false)
}
</script>

<template>
  <v-form ref="form" @submit.prevent="addPromotion">
    <v-container>
      <v-row>
        <v-col cols="12" sm="12" md="4">
          <v-text-field
            v-model="promotion.name"
            :rules="[(v) => !!v.trim() || 'Field is required']"
            class="mb-2"
            clearable
            label="Name:"
          ></v-text-field>
        </v-col>
        <v-col cols="12" sm="12" md="4">
          <v-text-field
            type="text"
            v-model="promotion.condition"
            :rules="[(v) => !!v.trim() || 'Field is required']"
            class="mb-2"
            clearable
            label="Condition:"
          ></v-text-field>
        </v-col>
        <v-col cols="12" sm="12" md="4">
          <v-text-field
            type="number"
            v-model.number="promotion.discount"
            min="1"
            :rules="[(v) => !!v || 'Field is required']"
            class="mb-2"
            clearable
            label="Discount:"
          ></v-text-field>
        </v-col>
        <v-col cols="12" sm="12" md="4">
          <v-select
            v-model="promotion.discountType"
            :rules="[(v) => !!v || 'Field is required']"
            :items="discountTypes"
            label="Discount Type"
            outlined
          ></v-select
        ></v-col>
        <v-col cols="12" sm="12" md="4">
          <v-text-field
            type="date"
            v-model="promotion.start"
            :rules="[(v) => !!v.trim() || 'Field is required']"
            class="mb-2"
            clearable
            label="Start Date:"
          ></v-text-field>
        </v-col>
        <v-col cols="12" sm="12" md="4">
          <v-text-field
            type="date"
            v-model="promotion.end"
            :rules="[(v) => !!v.trim() || 'Field is required']"
            class="mb-2"
            clearable
            label="End Date:"
          ></v-text-field>
        </v-col>

        <v-col cols="12" sm="6">
          <v-checkbox v-model="promotion.status" label="status "></v-checkbox>
        </v-col>
      </v-row>
    </v-container>
    <div class="pa-4 text-end">
      <v-btn
        class="text-none"
        color="medium-emphasis"
        min-width="92"
        variant="outlined"
        rounded
        @click="handleCloseDialog"
      >
        Close
      </v-btn>

      <v-btn type="submit" color="medium-emphasis" min-width="92" variant="outlined" rounded>{{
        promotionToEdit && promotionToEdit.value ? 'Update' : 'Submit'
      }}</v-btn>
    </div>
  </v-form>
</template>
